summaryrefslogtreecommitdiff
path: root/tests/misc/chroot-fail
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/chroot-fail')
-rwxr-xr-xtests/misc/chroot-fail50
1 files changed, 50 insertions, 0 deletions
diff --git a/tests/misc/chroot-fail b/tests/misc/chroot-fail
new file mode 100755
index 000000000..5b5829321
--- /dev/null
+++ b/tests/misc/chroot-fail
@@ -0,0 +1,50 @@
+#!/bin/sh
+# Verify that internal failure in chroot gives exact status.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chroot --version
+fi
+
+. $srcdir/test-lib.sh
+
+fail=0
+
+# These tests verify exact status of internal failure; since none of
+# them actually run a command, we don't need root privileges
+chroot # missing argument
+test $? = 125 || fail=1
+chroot --help --version # too many options
+test $? = 125 || fail=1
+chroot --- / true # unknown option
+test $? = 125 || fail=1
+
+# chroot("/") succeeds for non-root users on some systems, but not all.
+if chroot / true ; then
+ chroot / sh -c 'exit 2' # exit status propagation
+ test $? = 2 || fail=1
+ chroot / . # invalid command
+ test $? = 126 || fail=1
+ chroot / ... # no such command
+ test $? = 127 || fail=1
+else
+ test $? = 125 || fail=1
+fi
+
+Exit $fail